# coding: utf-8

"""
    Slices SSH Public Keys Service

    The Slices Public SSH Keys API  

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class PublicKey(BaseModel):
    """
    Public Key.
    """ # noqa: E501
    public_key: StrictStr
    tags: Optional[List[StrictStr]] = None
    id: StrictInt
    user_id: Annotated[str, Field(strict=True)]
    created_at: datetime = Field(description="Timestamp when this public key was registered.")
    sha256_fingerprint: StrictStr = Field(description="SHA256 fingerprint of the public key.")
    __properties: ClassVar[List[str]] = ["public_key", "tags", "id", "user_id", "created_at", "sha256_fingerprint"]

    @field_validator('user_id')
    def user_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(r"must validate the regular expression /user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PublicKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "sha256_fingerprint",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PublicKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "public_key": obj.get("public_key"),
            "tags": obj.get("tags"),
            "id": obj.get("id"),
            "user_id": obj.get("user_id"),
            "created_at": obj.get("created_at"),
            "sha256_fingerprint": obj.get("sha256_fingerprint")
        })
        return _obj


